{ neovim, vimPlugins, luajitPackages, nvim-agda }:

neovim.override {
  configure = {
    plug = {
      plugins = with vimPlugins; [
        ctrlp-vim
        nerdtree
        nvim-agda
        vim-code-dark
        vim-polyglot
      ];
    };

    customRC = ''
      lua << EOF
        package.cpath = package.cpath .. ";${luajitPackages.luautf8}/lib/lua/5.1/lua-utf8.so"
      EOF

      set hidden
      set cursorline
      set number
      set splitright
      set modeline
      set expandtab
      set colorcolumn=80
      syntax on
      filetype on
      filetype plugin indent on
      colorscheme codedark

      nnoremap <C-n> :NERDTreeToggle<CR>
      imap kj <Esc>
    '';
  };
}
