{ nixpkgs, system, ... }:

let
  pkgs = nixpkgs.legacyPackages.${system};
in
pkgs.vimUtils.buildVimPlugin rec {
  pname = "nvim-agda";
  version = "2bed0b9a1d42f20438d22a3229c59faaf2b6a8df";
  src = pkgs.fetchFromGitHub {
    owner = "ashinkarov";
    repo = pname;
    rev = version;
    hash = "sha256-cMEOSGMyFHp/iABjpbxb3GFi4lBFYOhIDcI/EwgVgdw=";
  };
  buildPhase = ''
    for patch in ${./patches}/*; do
      echo Applying $patch...
      patch -p1 --verbose < $patch
    done

    mkdir autoload
    cp ${agda-vim-excerpts/autoload.vim} autoload/agda.vim
    cat ${agda-vim-excerpts/ftplugin.vim} >> ftplugin/agda.vim
    cat ${./keybinds.vim} >> ftplugin/agda.vim
  '';
}
